package swingevent;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

public class SwingEventDemo
{
  public static void main(String[] args)
  {
    TestFrame f = new TestFrame("SwingEventDemo"); //Fenster mit Rahmen

    f.addWindowListener(new BeendenWindowAdapter());

    f.setSize(400, 400);
    f.setLocation(200, 200);
    f.setVisible(true);
  }
}

class BeendenWindowAdapter
// Vergleiche die bliche, namenlose Schreibweise in SwingPaintDemo
extends WindowAdapter // Implementiert ein entsprechendes Listener-Interface mit leeren Methoden.
{
  public void windowClosing(WindowEvent we) // eine dieser Methoden berschreiben
  {
    System.exit(0);
  }
}

class TestFrame
extends JFrame
{
  Engine myEngine = new Engine(this);
  // Trick: Dank "this" wei die Engine, welches Objekt sie kontakten muss.
  JButton meinButton;
  JSlider meinRegler;
  JMenu meinMenu;
  JMenuBar menuBar;

  public TestFrame(String s)
  {
    super(s); // Konstruktor der Mutterklasse; bei C++ in Initialisiererliste

    // Schaltflche bauen
    meinButton = new JButton ("Klick mich!");
    meinButton.setSize(100, 50);
    meinButton.setLocation(20, 60);
    meinButton.setActionCommand("klick");
    getContentPane().add(meinButton);
    meinButton.addActionListener(myEngine); // Events an myEngine melden

    // Regler bauen
    meinRegler = new JSlider(JSlider.HORIZONTAL, 0, 100, 50);
    getContentPane().add(meinRegler);
    meinRegler.addChangeListener(myEngine); // Events an myEngine melden

    // Men bauen
    meinMenu = new JMenu("Tu was");
    JMenuItem menuEintragLaufen = new JMenuItem("Laufen");
    menuEintragLaufen.setActionCommand("lauf");
    menuEintragLaufen.addActionListener(myEngine); // Events an myEngine melden
    meinMenu.add(menuEintragLaufen);

    JMenuItem menuEintragBeenden = new JMenuItem("Springen");
    menuEintragBeenden.setActionCommand("spring");
    menuEintragBeenden.addActionListener(myEngine); // Events an myEngine melden
    meinMenu.add(menuEintragBeenden);

    menuBar = new JMenuBar();
    menuBar.add(meinMenu);
    setJMenuBar(menuBar);
  }

  public void paint(Graphics g)
  {
    super.paint(g);

    String a = myEngine.zahlButtonKlicks
               + "  " + myEngine.schieberPosition
               + "  " + myEngine.menuWahl;
    g.drawString(a, 20, 200);
  }
}

class Engine // Hier sind nachher die eigentlichen Daten/Rechnungen.
implements ActionListener, // fr Schaltflche und Men
           ChangeListener // fr Schieberegler
// implements = Versprechen, bestimmte Methoden zu besitzen,
// hnlich der in Java nicht erlaubten Mehrfachvererberung von C++
{
  TestFrame meinTestFrame; // Damit wir repaint aufrufen knnen.
  int zahlButtonKlicks=0;
  int schieberPosition=-1;
  String menuWahl="---";

  public Engine(TestFrame f)
  {
    meinTestFrame = f;
  }

  public void actionPerformed(ActionEvent e) // fr ActionListener
  {
    String c = e.getActionCommand();
    if(c.equals("klick"))
    {
      zahlButtonKlicks++;
    }
    else if(c.equals("lauf") || c.equals("spring"))
    // Vorsicht: == wrde nur Identitt der Objekte vergleichen.
    {
      menuWahl=c;
    }
    meinTestFrame.repaint();
  }

  public void stateChanged(ChangeEvent e) // fr ChangeListener
  {
    // Leider steht der neue Wert im Event nicht drin,
    // wir gucken deshalb in meinTestFrame.meinRegler nach.
    schieberPosition=meinTestFrame.meinRegler.getValue();
    meinTestFrame.repaint();
  }
}