// Bentigt GLUT!
// Fr Dev-C++ (also Mingw32) siehe http://sites.netscape.net/ptrpck/glut.htm
// mit GLUT linken: Project/Project options/Further object files or linker options:
// -lopengl32 -lglu32 -lglut32

// sozusagen Steuerbefehle fr GLUT:
#define GLUT_NO_LIB_PRAGMA
// Sonst generiert glut.h besondere Anweisungen fr MSVC, um Bibliotheken einzubinden.
#define GLUT_NO_WARNING_DISABLE
// Sonst versucht glut.h, Warnungen fr MSVC abzuschalten (die es bei Mingw32 nicht gibt).

#include <stdio.h> // fr Ausgaben ins Terminalfenster
#include <gl/glut.h> // Unterverzeichnis gl enthlt die OpenGL-spezifischen Header

void renderScene()
{
    glClear(GL_COLOR_BUFFER_BIT); // RGB-Puffer lschen
    glFlush(); // Kommandopuffer abarbeiten, falls noch nicht getan
    printf("renderScene\n");
}

// eine zweite Render-Funktion, fr das zweite Fenster
void renderScene2()
{
    glClear(GL_COLOR_BUFFER_BIT);
    glFlush();
    printf("renderScene2\n");
}

void changeSize(GLsizei w, GLsizei h)
{
    printf("changeSize\n");
}

void specialFunc(int key, int x, int y)
{
    switch(key)
    {
    case GLUT_KEY_RIGHT:
        printf("Cursor nach rechts\n");
        break;
    case GLUT_KEY_LEFT:
        printf("Cursor nach links\n");
        break;
    case GLUT_KEY_UP:
        printf("Cursor nach oben\n");
        break;
    case GLUT_KEY_DOWN:
        printf("Cursor nach unten\n");
        break;
    default:
        ;
    }
}

void mouseFunc(int button, int state, int x, int y)
{
    if( button==GLUT_LEFT_BUTTON && state==GLUT_DOWN)
    {
        printf("linke Maustaste gedrueckt an (%d, %d)\n", x, y);
    }
}

int main(int argc, char* argv[])
{
    glutInit(&argc, argv);

    glutInitWindowSize(400, 300);
    glutInitWindowPosition(34, 45);

    // berflssig, da Standard: glutInitDisplayMode(GLUT_RGB | GLUT_SINGLE);
    glutCreateWindow("GUI mit GLUT");

    // Callback-Funktionen fr GLUT installieren
    glutDisplayFunc(renderScene);
    glutReshapeFunc(changeSize);
    glutSpecialFunc(specialFunc);
    glutMouseFunc(mouseFunc);
    // und ggf. weitere Callbacks

    // zur Demonstration noch ein paar Fenster

    glutInitWindowSize(200, 100);
    glutInitWindowPosition(234, 345);
    glutCreateWindow("ein zweites Fenster");
    glutDisplayFunc(renderScene2); // knnte auch die alte Funktion sein
    glutReshapeFunc(changeSize); // etc.
    // und ggf. weitere Callbacks

    glutInitWindowSize(250, 40);
    glutInitWindowPosition(123, 234);
    glutCreateWindow("ein drittes Fenster");
    glutDisplayFunc(renderScene);
    // etc.

    glutMainLoop();

    printf("Wird nie erreicht!\n");
    return 0;
}
